package tournament;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.filechooser.FileNameExtensionFilter;

import tournament.xml.TournamentData;

public class InfoPanel extends JPanel {
	
	private JLabel textField;
	private JLabel textField2;
	private Tournament tournament;
	private JLabel descField;
	private JLabel descField2;
	private JLabel iconLabel;
	private JLabel versusField;
	private JLabel resultField;
	private JLabel dateField = null;
	
	private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");

	public InfoPanel(Tournament tournament)
	{
		super(new BorderLayout());
		this.tournament = tournament;
		tournament.infoPanel = this;
		setBackground(Color.BLACK);
		initComponents();
	}
	
	public void setDate(Date date)
	{
		dateField.setText(sdf.format(date));
	}
	
	public void clear()
	{
		iconLabel.setIcon(null);
		textField.setText("");
		descField.setText("");
	}

	public void initComponents()
	{
		setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		setLayout(new GridBagLayout());
		setBackground(Color.BLACK);
		GridBagConstraints c = new GridBagConstraints();
		
//		JPanel flowpanel = new JPanel (new FlowLayout());
		ImageIcon icon = new ImageIcon("wm06/argentinien.gif");
		iconLabel = new JLabel();
		iconLabel.setPreferredSize(new Dimension(50,50));
		iconLabel.setIcon(icon);
		iconLabel.setForeground(Color.WHITE);
//		c.fill = GridBagConstraints.HORIZONTAL;
		Insets oldInsets = c.insets;
		c.insets = new Insets(5,15,5,5);
		c.gridheight = 2;
		c.gridx = 0;
		c.gridy = 0;
		this.add(iconLabel, c);
		c.gridheight = 1;
		
//		c.insets = oldInsets;
		c.insets = new Insets(5,5,5,5);
		
//		JPanel panel = new JPanel (new GridLayout(2,3,0,-5));
//		panel.setBackground(Color.BLACK);
		textField = new JLabel();
		textField.setFont(new Font("Tahoma", Font.BOLD, 14));
		textField.setText("NAME");
		textField.setForeground(Color.WHITE);
//		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.WEST;
//		c.weightx = 1.0;
		c.gridheight = 1;
		c.gridx = 1;
		c.gridy = 0;
		add(textField, c);
		
		descField = new JLabel();
		descField.setFont(new Font("Tahoma", Font.PLAIN, 14));
		descField.setText("Description");
		descField.setForeground(Color.WHITE);
		c.anchor = GridBagConstraints.WEST;
		c.gridheight = 1;
		c.gridx = 1;
		c.gridy = 1;
		add(descField, c);
		
		c.insets = new Insets(0,15,0,15);
		versusField = new JLabel();
		versusField.setFont(new Font("Tahoma", Font.BOLD, 16));
		versusField.setText("VS");
		versusField.setForeground(Color.WHITE);
		c.anchor = GridBagConstraints.CENTER;
		c.gridx = 2;
		c.gridy = 0;
		c.gridheight = 1;
		add(versusField, c);		
		
		resultField = new JLabel();
		resultField.setFont(new Font("Tahoma", Font.PLAIN, 16));
		resultField.setText("2:1");
		resultField.setForeground(Color.WHITE);
		c.gridx = 2;
		c.gridy = 1;
		c.gridheight = 1;
		add(resultField, c);		
		
		c.gridheight = 1;
		c.insets = new Insets(5,5,5,5);
		textField2 = new JLabel();
		textField2.setFont(new Font("Tahoma", Font.BOLD, 14));
		textField2.setText("NAME2");
		textField2.setForeground(Color.WHITE);
		c.anchor = GridBagConstraints.EAST;
		c.gridx = 3;
		c.gridy = 0;
		add(textField2, c);
//		
		descField2 = new JLabel();
		descField2.setFont(new Font("Tahoma", Font.PLAIN, 14));
		descField2.setText("Description");
		descField2.setForeground(Color.WHITE);
		c.gridy = 1;
		add(descField2, c);
//		
		JLabel dLabel = new JLabel("Game Date");
		dLabel.setFont(new Font("Tahoma", Font.BOLD, 12));
		dLabel.setBackground(Color.BLACK);
		dLabel.setForeground(Color.WHITE);
		dLabel.setVerticalAlignment(JLabel.BOTTOM);
		c.anchor = GridBagConstraints.CENTER;
		c.weightx = 1;
		c.gridx = 4;
		c.gridy = 0;
		add(dLabel, c);
//		
		dateField = new JLabel();
		dateField.setFont(new Font("Tahoma", Font.PLAIN, 12));
		dateField.setText("Date");
		dateField.setForeground(Color.WHITE);
		c.gridy = 1;
		c.anchor = GridBagConstraints.CENTER;
		add(dateField, c);	
		c.weighty = 0;

		
		JButton btn1 = new JButton();
		btn1.setText("Edit/New");
		btn1.addActionListener(new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent e)
			{
				new TournamentEditor(tournament);				
			}});
		JButton btn2 = new JButton();
		btn2.setText("Load");
		btn2.addActionListener(new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent e)
			{
				String dir = Main.class.getResource("Main.class").toString();
				System.out.println(dir);
				if (dir.startsWith("jar:")) dir = dir.substring(4);
				if (dir.contains(".jar!")) dir = dir.substring(0, dir.lastIndexOf(".jar!"));
				dir = dir.substring(6, dir.lastIndexOf("/"));
			    JFileChooser chooser = new JFileChooser(dir);
			    FileNameExtensionFilter filter = new FileNameExtensionFilter("XML Files", "xml");
			    chooser.setFileFilter(filter);
			    System.out.println(dir);
			    int returnVal = chooser.showOpenDialog(InfoPanel.this);
			    if(returnVal == JFileChooser.APPROVE_OPTION) {
			       System.out.print(" file: " + chooser.getSelectedFile().getAbsolutePath());
			       TournamentData td = new TournamentData(chooser.getSelectedFile().getAbsolutePath());
			       if (td.parse()){
			    	   System.out.println("loaded successfully");
//			    	   tournament.resetTippManager(td.getTeamCount()/2);
			    	   tournament.tournamentData = td;
			    	   tournament.buildTournamentTree(td.getTeamCount(), td.getAllTeamsAsStrings());
			    	   tournament.repaint();
			       }
			    }
			}});
		
		c.anchor = GridBagConstraints.LINE_END;
		c.insets = new Insets(0,7,0,7);
		c.weightx = 0.0f;
		c.gridheight = 2;
		c.gridx = 5;
		c.gridy = 0;
		add(btn1, c);
		c.anchor = GridBagConstraints.CENTER;
		c.gridheight = 2;
		c.gridx = 6;
		c.gridy = 0;
		add(btn2, c);
//		panel.add(new JLabel());
//		
//		add(panel, BorderLayout.LINE_END);
		setData("", "", "", "", "", "", "");
		versusField.setText("");
		this.doLayout();
		
	}
	
	public void setData(String iconstr, String name, String description)
	{
		ImageIcon icon = new ImageIcon (iconstr);
		iconLabel.setIcon(icon);
		
		textField.setText("   "+name);
//		textField2.setText(name);
		descField.setText("   "+description);
//		descField2.setText(description);
		versusField.setText("");
		this.doLayout();
		this.repaint();
	}
	
	public void setData(String iconstr, String name, String description, String iconstr2, String name2, String description2, String result)
	{
		ImageIcon icon = new ImageIcon (iconstr);
		iconLabel.setIcon(icon);
		
		textField.setText(name);
		textField2.setText(name2);
		descField.setText(description);
		descField2.setText(description2);
		versusField.setText("VS");
		resultField.setText(result);
		this.doLayout();
		this.repaint();
	}
	
	
	

}
