package tournament;

/**
 * Class Interpolator.
 * Dient zur Animierung des Turnierbaums
 */
public class Interpolator {
	private double[] myStart;
	private double[] myEnd;
	private double[] myDiff;
	public static double myTime;
	public static double myScale;
	public static boolean run;
	// sin(-pi/2 + x)/2 + 1
	// -cos(-pi/2 + x)/2 + x
	static final public double C1 = (-Math.cos(-Math.PI / 2 + 0)/2 - 0 / 2);
	static final public double C2 = (-Math.cos(-Math.PI / 2 + Math.PI)/2 + Math.PI / 2);
	static final public double C3 = 2;
	static final public double C4 = (-Math.cos(-Math.PI / 2 + 0)/2 - 0 / 2);
	static final public double C5 = (-Math.cos(-2.5 * Math.PI + 4 * Math.PI)/2 + 4 * Math.PI / 2);
	static final public double C6 = C2 - C1 + C3 + C5 - C4;
	
/**
 * Initialisierung des Interpolator-Objekts
 * @param start Array von Startwerten
 * @param end Array von Zielwerten
 */
	public Interpolator(double[] start, double[] end) {
		myStart = start;
		myEnd = end;
		myScale = 0;
		myDiff = new double[myStart.length];
		
		for( int i = 0; i < myStart.length; i++) {
			myDiff[i] = myEnd[i] - myStart[i];
		}
	}

/**
 * Liefert aktuelle Werte der Animation
 * @return Werte fuer aktuellen Zeitpunkt
 */	
	public double[] getValues() {
		double[] v = new double[myStart.length];
		double scale = getScale(); 
			
		for( int i = 0; i < myStart.length; i++) {
			v[i] = myStart[i] + myDiff[i] * scale;
		}		
		
		return v;
	}
	
/**
 * Ruecksetzen des Zeitzaehlers
 */	
	static public void reset() {
		myTime = 0;
	}
	
/**
 * Aktualisieren des Zeitzaehlers
 * @param dtime Zeitschritt
 */	
	static public void update(double dtime) {
		myTime = myTime + dtime;
	}	
	
/**
 * Liefert Skalierungswert fuer aktuellen Zeitpunkt
 * @return Skalierungswert
 */	
	static public double getScale() {		
		double dscale;
		
		if( myTime <= Math.PI )
			dscale = (-Math.cos(-Math.PI / 2 + myTime)/2 + myTime / 2) - C1;
		else if( myTime <= 3 * Math.PI ) {
			dscale = C2 - C1;
			dscale = dscale + myTime - Math.PI;
		}
		else if( myTime <= 4 * Math.PI ) {
			dscale = C2 - C1 + C3;
			dscale = dscale + (-Math.cos(-2.5 * Math.PI + myTime)/2 + myTime / 2) - C4;
		}
		else {
			run = false;
			return 1;
		}
		
		return dscale / C6;
	}
}
