package tournament;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class Main {
	
	
	
    public static void main(String argv[]) 
    {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    	
        final Tournament panel = new Tournament();
//    	TournamentEditor myExample = new TournamentEditor(panel);

        JPanel sliderpanel = new JPanel(new BorderLayout());
    	
    	JFrame frame = new JFrame("AdaptiviTree");
    	frame.setLayout(new BorderLayout());

    	JSlider slider = new JSlider();
    	panel.mySlider = slider;
    	panel.slidePanel = sliderpanel;

        sliderpanel.add(new InfoPanel(panel), BorderLayout.CENTER);
        
        
    	frame.getContentPane().add("South", sliderpanel);   	
        
        JScrollPane pane = new JScrollPane();
        
       
        panel.addMouseListener(panel);
        panel.addMouseMotionListener(panel);
                
        panel.setPreferredSize(new Dimension(800, 600));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        pane.getViewport().add(panel);
        
        frame.getContentPane().add("Center", pane);
         
        frame.pack();
        
        Vector<String> teamNames = new Vector<String>();
        
        for( int i = 1; i <=16; i++ )
        	teamNames.add( new String("Team" + Integer.toString(i)));
       
        panel.buildTournamentTree(16, teamNames);
            
        
        Interpolator.reset();
        
        pane.getViewport().addComponentListener(new ComponentAdapter() {

            public void componentResized(ComponentEvent e) {
            	panel.rearrange(e.getComponent().getWidth(), e.getComponent().getHeight());
            }
        });
        
//        panel.rearrange(800, 600);
                
        frame.setVisible(true);
        
        while( frame.isVisible() ) {
        	try
			{
				Thread.sleep(20);
			} catch (InterruptedException e1)
			{
				//e1.printStackTrace();
				continue;
			}
        	//System.out.println(Interpolator.myTime);
        	if( Interpolator.run == true ) {
        		Interpolator.update(0.2);
        		panel.repaint();
        	}
        }
    }
 }
