package tournament;

import java.awt.Graphics2D;
import java.awt.Point;

public abstract class Node {
	public Node(int dir) { DIR = dir; }
	public final int DIR;
	public Node myParent;

/**
 * Liefert den Anschlusspunkt zum Zeichnen des Baumes
 */	
	public abstract Point getTiePoint();
/**
 * Zeichnen des Node-Objekts.
 */		
	public abstract void paint(Graphics2D g);
	
	public abstract void paintRectangle(Graphics2D g, int x, int y);
	
	protected Interpolator myInterpolator1;
	protected Interpolator myInterpolator2;

/**
 * Liefert den Namen der Mannschaft bzw. des Spielers
 */	
	public abstract String getName();
/**
 * Liefert den Status des Spiels
 * A/B - Sieger Mannschaft oder noch unentschieden (UNDECIDED)
 */	
	public abstract int getState();
/**
 * Setzen des zugehoerigen Nodes in der naechsthoeheren Ebene
 * @param n Elternknoten
 */
	public abstract void setParentNode(Node n);
/**
 * Stellt fest ob die Mannschaft in einer hoeheren Turnierebene ein Spiel verloren hat
 * @param n Node-Objekt fuer das die Ueberpruefung durchgefuehrt wird
 * @return true wenn ein Spiel verloren wurde
 */
	public abstract boolean losesInFuture(Node n);
/**
 * Stellt fest ob auf einer niedrigeren Ebene ein Vorgaengerspiel den Status unentschieden hat
 * @return true wenn ein Spiel noch unentschieden ist
 */		
	public abstract boolean undecidedChild();
/**
 * Neuberechnung der Zielwerte der Animation
 */		
	public abstract void update();
/**
 * Initialisierung der Ziel- und Startwerte der Animation
 */	
	public abstract void init();
}
