package tournament.xml;

public class Team {
	
	private String name;
	private String description;
	private String icon;
	
	/**
	 * Creates a new Team with it's name, description and icon.
	 * @param name name of the team
	 * @param description descr. of the team
	 * @param icon path to the icon for the team
	 */
	public Team (String name, String description, String icon)
	{
		this.name = name;
		this.description = description;
		this.icon = icon;
	}
	
	/**
	 * name of the team
	 */
	public String toString()
	{
		return name;
	}

	/**
	 * Gets the name of the team
	 * @return name as string
	 */
	public String getName() 
	{
		return name;
	}

	/**
	 * Gets the description of the team
	 * @return descr. of the team
	 */
	public String getDescription() 
	{
		return description;
	}

	/**
	 * Gets the path to the icon of the team
	 * @return path to the icon
	 */
	public String getIcon()
	{
		return icon;
	}

}
