package tournament.xml;

import java.text.SimpleDateFormat;
import java.util.Date;

import junit.framework.TestCase;
import static org.junit.Assert.*;

public class XMLParserTests extends TestCase {
	
	@org.junit.Test
	public void testDefaultParsing()
	{
		TournamentData myParser = new TournamentData();

		assertTrue("parsing failed", myParser.parse());
		
		for (Team team:myParser.getAllTeams())
			System.out.println(String.format("%s (%s, %s) ", team, team.getDescription(),team.getIcon() ));
		
		for (GameResult game:myParser.getAllGames())
			System.out.println(String.format("%s (%s, %s) ", game, game.getDescription(), game.getDateAsString()));
	}
	
	@org.junit.Test
	public void testInvalidGameResult()
	{
		GameResult game = new GameResult("asdf", "1", "descr", "2006-01-01 01:10");
		assertFalse(game.isValid());
		
		game = new GameResult("1:2", "sadf", "descr", "2006-01-01 01:10");
		assertFalse(game.isValid());
		
		game = new GameResult("1:", "12", "descr", "2006-01-01 01:10");
		assertFalse(game.isValid());	

		game = new GameResult(":2", "12", "descr", "2006-01-01 01:10");
		assertFalse(game.isValid());
		
		game = new GameResult("1:2", "2", "descr", "2006-01-01");
		assertFalse(game.isValid());
		
		game = new GameResult("1:2", "2", "descr", "2006 01-01 01:10");
		assertFalse(game.isValid());
		
		game = new GameResult("1:2", "2", "descr", "2006-01-01 01:10");
		assertTrue(game.isValid());
	}
	
	
	@org.junit.Test
	public void testRegex()	
	{
		assertTrue("341:245".matches("^[0-9]+:[0-9]+$"));
		SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd HH:mm" );
		Date date = new Date();
		System.out.println(df.format(date));
	}

}

